
/**
 * An introduction to Strings and String methods.
 *
 * @author Wilhem Alcivar
 */
public class StringParser
{
    /**
     * Takes a String and returns that String with all characters uppercased.
     * E.G. cat would become CAT. dOnUt would become DONUT.
     *
     * @param s
     * @return String
     */
    public static String upperCaseString(String s)
    {
        return s.toUpperCase();
    }

    /**
     * Takes a String and returns that String with all characters lowercased.
     * E.G. MOUSE would become mouse. dOnUt would become donut.
     *
     * @param s
     * @return String
     */
    public static String lowerCaseString(String s) {
        return s.toLowerCase();
    }

    /**
     * Takes a String and returns the first character of that string.
     * E.G. cat would return c. Embark would return E.
     *
     * @param s
     * @return String
     */
    public static Character getFirstCharacter(String s) {
        String convert = s.substring(0,1);
        char solution = convert.charAt(0);
        return solution;
    }

    /**
     * Takes a String and returns the character at index n of that string.
     * E.G. cat, 2 would return t. Embark, 4 would return r.
     *
     * @param s
     * @param n
     * @return String
     */
    public static Character getNthCharacter(String s, Integer n) {
        int firstnum = n + 1;
        String thechar = s.substring(n,firstnum);
        char itsthechar = thechar.charAt(0);
        return itsthechar;
    }

    /**
     * Takes a String and returns that string with the first character uppercased.
     * E.G. cat would return Cat. cofFee would return CofFee.
     *
     * @param s
     * @return String
     */
    public static String upperCaseFirstCharacter(String s) {
        int length = s.length();
        String upperchar = s.substring(0,1).toUpperCase();
        return upperchar + s.substring(1,length);
    }

    /**
     * Takes a String and returns that string with the first character of each word in it uppercased
     * and then joined.
     * E.G. dog whistle would return DogWhistle. adjuNCT pRoFessOR would return AdjuctProfessor.
     *
     * @param s
     * @return String
     */
    public static String camelCaseString(String s) {
    String[] splitem = s.split("\\s+");
    String upperchar1 = splitem[0].substring(0,1).toUpperCase();
    String upperchar2 = splitem[1].substring(0,1).toUpperCase();
    String lowerchar1 = splitem[0].substring(1,splitem[0].length()).toLowerCase();
    String lowerchar2 = splitem[1].substring(1,splitem[1].length()).toLowerCase();
    return upperchar1 + lowerchar1 + upperchar2 + lowerchar2;
    }

    /**
     * Takes a String and returns that string with each character lowercased
     * and then joined with an underscore
     * E.G. dog whistle would return dog_whistle. adjuNCT pRoFessOR would return adjuct_professor.
     *
     * @param s
     * @return String
     */
    public static String snakeCaseString(String s) {
    String[] splitem = s.split("\\s+");
    String first = splitem[0].toLowerCase();
    String second = splitem[1].toLowerCase();
    return first + "_" + second;
    }

    /**
     * Takes a String and returns the length of that string
     * E.G. cat would return 3. extra would return 5.
     *
     * @param s
     * @return String
     */
    public static Integer getLength(String s) {
        return s.length();
    }

    /**
     * Takes in two strings and returns true if they are equal
     * E.G. example and shelf would return false. 
     * cat and CaT would return false. 
     * Dog and Dog would return true
     *
     * @param s1
     * @param s2
     * @return String
     */
    public static Boolean isEqual(String s1, String s2) {
        if (s1 == s2) {return true;} else {return false;}
    }

    /**
     * Takes in two strings and returns true if they are equal
     * E.G. example and shelf would return false. 
     * cat and CaT would return true. 
     * Dog and Dog would return true
     *
     * @param s1
     * @param s2
     * @return String
     */
    public static Boolean isEqualIgnoreCase(String s1, String s2) {
        return s1.equals(s2);
    }
}
